/* Test syscall overhead */
#include <stdio.h>
#include <sys/time.h>
#include <flex.h>
#include <string.h>
#include <stdlib.h>

#define N 50000000

/*
 * returns t2 - t1 in seconds as a double 
 */
double duration(struct timeval *t1, struct timeval *t2) {
    return (t2->tv_sec - t1->tv_sec) + (t2->tv_usec - t1->tv_usec) / (double)1000000.0;
}


int main(int argc, char *argv[]) {
    struct timeval start, end, s2, f2, s3, f3;
    struct timespec zerowait = {.tv_sec = 0, .tv_nsec = 0};
    int i;
    io_context_t ctx;
    struct io_event events[1];
    int num;

    if (argc < 2) {
	    printf("pass test number as argument\n");
	    exit(-1);
    }

    num = atoi(argv[1]);
   
    if (num == 1) {
    gettimeofday(&start, 0);
    for (i = 0; i < N; i++ ) {
        getpid();
    }
    gettimeofday(&end, 0);

    printf("Per-syscall overhead: %g\n", duration(&start, &end) / N);
    }

    memset(&ctx, 0 ,sizeof(ctx));
    if (io_setup(1024, &ctx) < 0) {
        perror ("setting up ioctx");
        exit (-1);
    }
   
    if (num == 2) {
    gettimeofday(&s2, 0);
    for (i = 0; i < N; i++) {
        if (io_getevents_syscall(ctx, 1, 1, events, &zerowait) < 0) {
            perror ("getting events");
            exit (-1);
        }
    }
    gettimeofday(&f2, 0);
    printf("Syscall io_getevent time: %g\n", duration(&s2, &f2) / N);
    }

    if (num == 3) {
    gettimeofday(&s3, 0);
    for (i = 0; i < N; i++) {
        if (io_getevents(ctx, 1, 1, events, &zerowait) < 0) {
            perror ("getting events");
            exit (-1);
        }
    }
    gettimeofday(&f3, 0);
    printf("Mmaped io_getevent time: %g\n", duration(&s3, &f3) / N);
    }

}
